--[[ Skinning module

	Many thanks to the work of Garan which has allowed me to demystify the scale setting. 
																			]]--

path="JackdawPlugins/Bevy2/Skins/"
import "JackdawPlugins.Bevy2.Skins.Skinlist"

function intialiseskin()
	for i=1,#Bar do
		if Bar[i].Data.skin~=nil then Bar[i]:Skin() end
	end
end

function NewBar:Skin()
	if self.Data.skin==nil then return end
		
	--Error checking in case the image has been deleted
	local test=pcall(function () local testing=Skins.SkinList[self.Data.skin][1] end)
	if test==false then ColorWrite(0.5,0.5,0.5,"Skin "..self.Data.skin.. " has been deleted! resetting this bar to no skin") self.Data.skin=nil return end
	
	--Basic Data
	local sx,sy=self.Data.sx,self.Data.sy
	local pad=self.Data.pad or 2
	local gap=self.Data.gap or  2
	local size=self.Data.size or 36
	local skinfile=path..Skins.SkinList[self.Data.skin][1]
	local skinsize=Skins.SkinList[self.Data.skin][2]
	
	if self.SkinControl==nil then self.SkinControl={} end
	--Delete all current skin controls
	for i=1,#self.SkinControl do
		self.SkinControl[i]:SetVisible(false)
		self.SkinControl[i]=nil
	end
	
	--**Much of the next section is copied from the quickslot positioning code from class.lua**
	--Things just don't QUITE line up. How annoying is that?!
	--The following, after lots of tweaking, give the best centering
	local adjust=math.floor(size/10)
	local actualsize=size-adjust
	local skinadjust=actualsize+(adjust+1)*2
	local positionadjust=(adjust+1)/2
	
	n=1
	for i=1,sx do
		for j=1,sy do
			self.SkinControl[n]=Turbine.UI.Control()

			self.SkinControl[n]:SetParent(self.Window)
			
			self.SkinControl[n]:SetSize(skinsize,skinsize)
			self.SkinControl[n]:SetBackground (skinfile)
			self.SkinControl[n]:SetStretchMode(1)
			self.SkinControl[n]:SetSize(skinadjust,skinadjust)
			
			self.SkinControl[n]:SetMouseVisible(false)
			self.SkinControl[n]:SetVisible(true)
			self.SkinControl[n]:SetOpacity(self:GetOpacity())
			local x,y=self.Quickslot[n]:GetPosition()
			x=x-positionadjust
			y=y-positionadjust
			
			self.SkinControl[n]:SetPosition(x,y)
			n=n+1
		end
	end	
end

--Add the "Skin Bar" option to every Bar.
table.insert(Context,
function (self,contextMenu,contextMenuItems)

			local SkinBar = Turbine.UI.MenuItem( "Select Skin");
				contextMenu.Skins = SkinBar:GetItems()
				SkinMenu={}
				--for i in pairs(Skins.SkinList) do
				for j=1,#Skins.orderedskinlist do
					i=Skins.orderedskinlist[j]
					
					SkinMenu[j]= Turbine.UI.MenuItem( i,true, self.Data.skin==i );
					SkinMenu[j].Click = function( sender, args )
							self.Data.skin=Skins.orderedskinlist[j]
							self:Skin()
					end
						contextMenu.Skins:Add(SkinMenu[j])
				end
				SkinMenu[9999]= Turbine.UI.MenuItem( "No Skin",true );
				SkinMenu[9999].Click = function( sender, args )
						self.Data.skin=nil
						--Delete all current skin controls
							for i=1,#self.SkinControl do
								self.SkinControl[i]:SetVisible(false)
								self.SkinControl[i]=nil
							end
						self.SkinControl=nil
				end
					contextMenu.Skins:Add(SkinMenu[9999])
			contextMenuItems:Add( SkinBar )
end)

--Option Box functions

table.insert(Opt.Module,
	function()
		Opt.SkinCB=CollapseBox("Skin Options","f",1,true)
		Opt.ListBox:AddItem(Opt.SkinCB)
	
			local SkinTable=Skins.orderedskinlist
			table.insert(SkinTable,1,"No Setting")

			Opt.skin=Opt.DropDown(
			SkinTable,
			
			function(k,i)
				if k==0 then
					if Bar[i].Data.skin~=nil then
						Bar[i].Data.skin=nil
						--Delete all current skin controls
							for b=1,#Bar[i].SkinControl do
								Bar[i].SkinControl[b]:SetVisible(false)
								Bar[i].SkinControl[b]=nil
							end
						Bar[i].SkinControl=nil
					end
				else
					Bar[i].Data.skin=Skins.orderedskinlist[k+1]
				end
	
				Bar[i]:Skin()

			end)
		Opt.SkinCB.Content:AddItem(Opt.skin)
		table.insert(Opt.source,"skin")

		end)

intialiseskin()